import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;


public class Main {
	
	private static Scanner in;

	public static void fillRoomByBookcase(int[][] room, int[] bc) {
		for(int i = 0; i < bc[2]; i++) {
			for(int j = 0; j < bc[3]; j++) {
				room[bc[0] + i][bc[1] + j] = 1;
			}
		}
	}
	
	public static boolean tryPutTable(int[][] room, int x, int y, boolean isHor) {
		if (x <= 0 || y <= 0 || y + 3 > room.length || x + 3 > room[0].length) return false;
		
		if (isHor) {
			if (x + 4 > room[0].length) return false;			
			for(int i = -1; i < 3; i++)
				for(int j = -1; j < 4; j++)
					if (room[y + i][x + j] > 0) return false;
			for(int i = 0; i < 2; i++)
				for(int j = 0; j < 3; j++)
					room[y + i][x + j] = 2;
		} else {
			if (y + 4 > room.length) return false;			
			for(int i = -1; i < 4; i++)
				for(int j = -1; j < 3; j++)
					if (room[y + i][x + j] > 0) return false;
			for(int i = 0; i < 3; i++)
				for(int j = 0; j < 2; j++)
					room[y + i][x + j] = 2;
		}
		
		return true;
	}
	
	public static void removeTable(int[][] room, int x, int y, boolean isHor) {
		if (isHor) {
			for(int i = 0; i < 2; i++)
				for(int j = 0; j < 3; j++)
					room[y + i][x + j] = 0;
		} else {
			for(int i = 0; i < 3; i++)
				for(int j = 0; j < 2; j++)
					room[y + i][x + j] = 0;			
		}
	}
	
	public static int findSolution(int[][] room) {
		int maxS = 0;
		for(int i = 1; i < room.length - 1; i++) {
			for(int j = 1; j < room[0].length - 1; j++) {
				if (tryPutTable(room, j, i, true)) {
					int s = findSolution(room) + 1;
					removeTable(room, j, i, true);
					maxS = Math.max(maxS, s);
				}
				if (tryPutTable(room, j, i, false)) {
					int s = findSolution(room) + 1;
					removeTable(room, j, i, false);
					maxS = Math.max(maxS, s);
				}
			}
		}
		return maxS;
	}

	public static void main(String[] args) throws FileNotFoundException {
		in = new Scanner(new File("job.in"));
		int t = in.nextInt();
		for(int ti = 0; ti < t; ti++) {
			int[][] room = new int[in.nextInt()][in.nextInt()];
			int b = in.nextInt();
			for(int i = 0; i < b; i++) {
				int[] bc = new int[4];				
				for(int j = 0; j < 4; j++)
					bc[j] = in.nextInt();
				fillRoomByBookcase(room, bc);
			}
			
			System.out.println(findSolution(room));			
		}
	}

}
