import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

import javax.management.RuntimeErrorException;


public class Main {

	static long MOD = 2017l;
	
	static long [][] pascal = new long[15][15];
	static long [] fact = new long[15];
	
	static void init(){
		for (int i = 0; i<pascal.length; ++i){
			Arrays.fill(pascal[i], 0);
			pascal[i][0] = 1;
			for (int j=1;  j<=i; ++j){
				pascal[i][j] = (pascal[i-1][j]+pascal[i-1][j-1]) % MOD;
			}
		}
		fact[0] = 1;
		for (int i = 1; i<fact.length; i++){
			fact[i] = (fact[i-1]*i)%MOD;
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner in = new Scanner("kohinoor.in");
		PrintWriter out = new PrintWriter(System.out);
		init();
		
		int _ =in.nextInt();
		while(_-->0){
			int n = in.nextInt();
			int k = in.nextInt();
			long ans = 0;
			for (int i =0; i<k; i++){
				ans += ((i&1)>0?-1:1) * binpow(k-i, n) * pascal[k][i];
				ans %= MOD;
			}
			
			System.out.println(div(ans, fact[k]));
		}
		
	}

	static long div(long a, long b){
		while(a%b!=0) a+=MOD;
		return a/b;
	}
	
	static long binpow(long base, long pow){
		if (pow == 0) return 1l;
		long ans = 1;
		if ((pow&1)>0)
		{
			ans *= base;
			ans %= MOD;
		}
		long tmp = binpow(base, pow>>1);
		ans *= tmp;
		ans %= MOD;
		ans *= tmp;
		ans %= MOD;
		return ans;
	}
}

class Scanner {
	BufferedReader reader;
	StringTokenizer t = new StringTokenizer("");
	
	public Scanner(String fname) {
		try {
			reader = new BufferedReader(new FileReader(fname));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	String nextLine(){
			try {
				t = new StringTokenizer("");
				return reader.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				throw new RuntimeException();
			}
		
	}
	
	String next(){
		while (!t.hasMoreTokens()) t = new StringTokenizer(nextLine());
		return t.nextToken();
	}
	
	long nextLong(){
		return Long.parseLong(next());
	}
	
	int nextInt(){
		return Integer.parseInt(next());
	}
	
	
}